Attribute VB_Name = "modLibZPlay"
' '
' '  libzplay - windows ( WIN32 ) multimedia library
' '
' '  ver: 2.00
' '  date: 22. April, 2010.
' '
' '  Copyright (C) 2003-2010 Zoran Cindori
' '
' '  Author: Zoran Cindori
' '  Web: http://libzplay.sourceforge.net/
' '  Email: zcindori@inet.hr
' '
' '
' '  This program is free software; you can redistribute it and/or modify
' '  it under the terms of the GNU General Public License as published by
' '  the Free Software Foundation; either version 2 of the License, or
' '  (at your option) any later version.
' '
' '  This program is distributed in the hope that it will be useful,
' '  but WITHOUT ANY WARRANTY; without even the implied warranty of
' '  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' '  GNU General Public License for more details.
' '
' '  You should have received a copy of the GNU General Public License
' '  along with this program; if not, write to the Free Software
' '  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
' '
' '
' '
' ' Supported by:
' '
' ' ============================================================================
' ' libmad - MPEG audio decoder library
' ' Copyright (C) 2000-2004 Underbit Technologies, Inc. <support@underbit.com>
' ' http://www.underbit.com/products/mad/
' ' GNU General Public License ( GPL.TXT )
' ' ============================================================================
' ' THE OggVorbis SOURCE CODE IS (C) COPYRIGHT 1994-2002
' ' by the Xiph.Org Foundation http://www.xiph.org/
' ' BSD-STYLE SOURCE LICENSE  ( XIPH.TXT )
' ' ============================================================================
' ' LIBA52
' ' free library for decoding ATSC A/52 streams.
' ' It is released under the terms of the GPL license.
' ' ============================================================================
' ' FLAC - Free Lossless Audio Codec
' ' Copyright (C) 2001,2002,2003,2004,2005,2006,2007  Josh Coalson
' ' http://flac.sourceforge.net/
' '
' ' This file is part the FLAC project.  FLAC is comprised of several
' ' components distributed under difference licenses.  The codec libraries
' ' are distributed under Xiph.Org's BSD-like license (see the file
' ' XIPH.TXT in this distribution).  All other programs, libraries, and
' ' plugins are distributed under the LGPL or GPL (see LGPL.TXT and
' ' GPL.TXT).  The documentation is distributed under the Gnu FDL (see
' ' FDL.TXT).  Each file in the FLAC distribution contains at the top the
' ' terms under which it may be distributed.
' '
' ' Since this particular file is relevant to all components of FLAC,
' ' it may be distributed under the Xiph.Org license, which is the least
' ' restrictive of those mentioned above.  See the file XIPH.TXT in this
' ' distribution.
' ' ============================================================================
' ' FAAD2 - Freeware Advanced Audio (AAC) Decoder including SBR decoding
' ' Copyright (C) 2003-2005 M. Bakker, Nero AG, http://www.nero.com
' '
' ' This program is free software; you can redistribute it and/or modify
' ' it under the terms of the GNU General Public License as published by
' ' the Free Software Foundation; either version 2 of the License, or
' ' (at your option) any later version.
' '
' ' This program is distributed in the hope that it will be useful,
' ' but WITHOUT ANY WARRANTY; without even the implied warranty of
' ' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' ' GNU General Public License for more details.
' '
' ' You should have received a copy of the GNU General Public License
' ' along with this program; if not, write to the Free Software
' ' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
' '
' ' Any non-GPL usage of this software or parts of this software is strictly
' ' forbidden.
' '
' ' The "appropriate copyright message" mentioned in section 2c of the GPLv2
' ' must read: "Code from FAAD2 is copyright (c) Nero AG, www.nero.com"
' '
' ' Commercial non-GPL licensing of this software is possible.
' ' For more info contact Nero AG through Mpeg4AAClicense@nero.com.
' '
' ' ============================================================================
' ' FAAC - Freeware Advanced Audio Coder Copyright (C) 2001 M. Bakker
' ' This library is free software; you can redistribute it and/or modify it
' ' under the terms of the GNU Lesser General Public License as published by the
' ' Free Software Foundation; either version 2.1 of the License, or
' ' (at your option) any later version.
' '
' ' This library is distributed in the hope that it will be useful,
' ' but WITHOUT ANY WARRANTY; without even the implied warranty of
' ' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
' ' See the GNU Lesser General Public License for more details.
' '
' ' You should have received a copy of the GNU Lesser General Public License
' ' along with this library; if not, write to the Free Software Foundation,
' ' Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
' '
' ' ============================================================================
' ' libmp3lame encoder
' ' LAME 3.xx LAME Ain't an MP3 Encoder http://www.mp3dev.org March 2001
' '
' ' Originally developed by Mike Cheng (www.uq.net.au/~zzmcheng).
' ' Now maintained by Mark Taylor (www.mp3dev.org).
' '
' ' This code is distributed under the GNU LESSER PUBLIC LICENSE (LGPL, see
' www.gnu.org)
' ' with the following modification:
' '
' ' If you determine that distribution of LAME requires a patent license,
' ' and you obtain a patent license, you may distribute LAME even though
' redistribution
' ' of LAME may also require a patent license.
' '
' ' You agree not to enforce any patent claims for any aspect of MPEG audio
' compression,
' ' or any other techniques contained in the LAME source code.
' '
' ' Copyrights (c) 1999-1007 by The LAME Project Copyrights (c) 1999,2000,2001
' ' by Mark Taylor Copyrights (c) 1999,2000,2001 by Mark Taylor Copyrights
' ' (c) 1998 by Michael Cheng Copyrights (c) 1995,1996,1997 by Michael Hipp: mpglib
' '
' ' ============================================================================
' ' SoundTouch library Copyright (c) Olli Parviainen 2002-2009
' ' http://www.surina.net/soundtouch
' ' GNU Lesser General Public License vesrion 2.1 (LGPL.TXT )
' ' ============================================================================
' ' Center Cut DSP Plugin for Winamp 2.x
' ' Copyright (C) 2004  Moitah (moitah@yahoo.com)
' ' GNU General Public License ( GPL.TXT )
' ' ============================================================================
' ' Shibatch Super Equalizer ver 0.03 for winamp
' ' written by Naoki Shibata  shibatch@users.sourceforge.net
' ' http://shibatch.sourceforge.net/
' '
' ' Shibatch Super Equalizer (except FFT part) is distributed under LGPL.
' ' See LGPL.txt for details.
' ' FFT part is a routine made by Mr.Ooura. This routine is a freeware.
' ' Contact Mr.Ooura for details of distributing licenses.
' ' http://momonga.t.u-tokyo.ac.jp/~ooura/fft.html
' ' ============================================================================
' ' The Independent JPEG Group's JPEG software
' ' JPEG decoding library
' ' Copyright (C) 1991-2010, Thomas G. Lane, Guido Vollbeding.
' ' www.ijg.org
' ' ============================================================================
' ' ZLIB DATA COMPRESSION LIBRARY
' ' (C) 1995-2010 Jean-loup Gailly and Mark Adler
' ' http://zlib.net/
' ' ============================================================================
' ' libpng library
' ' PNG picture decoding library
' ' Copyright (c) 2004, 2006-2007 Glenn Randers-Pehrson
' ' http://www.libpng.org/
' ' ============================================================================

' ' ============================================================================
' ' ActiveVB 2016
' ' converted from vb.net class "libZPlay.vb" to vbc
' ' Autor: Frank Schler
' ' ============================================================================

Option Explicit

' ----==== libZplay Public Enums ====----
Public Enum TSettingID
    sidWaveBufferSize = 1
    sidAccurateLength = 2
    sidAccurateSeek = 3
    sidSamplerate = 4
    sidChannelNumber = 5
    sidBitPerSample = 6
    sidBigEndian = 7
End Enum

Public Enum TStreamFormat
    sfUnknown = 0
    sfMp3 = 1
    sfOgg = 2
    sfWav = 3
    sfPCM = 4
    sfFLAC = 5
    sfFLACOgg = 6
    sfAC3 = 7
    sfAacADTS = 8
    sfWaveIn = 9
    sfAutodetect = 1000
End Enum

Public Enum TFFTWindow
    fwRectangular = 1
    fwHamming
    fwHann
    fwCosine
    fwLanczos
    fwBartlett
    fwTriangular
    fwGauss
    fwBartlettHann
    fwBlackman
    fwNuttall
    fwBlackmanHarris
    fwBlackmanNuttall
    fwFlatTop
End Enum

Public Enum TTimeFormat
    tfMillisecond = 1
    tfSecond = 2
    tfHMS = 4
    tfSamples = 8
End Enum

Public Enum TSeekMethod
    smFromBeginning = 1
    smFromEnd = 2
    smFromCurrentForward = 4
    smFromCurrentBackward = 8
End Enum

Public Enum TID3Version
    id3Version1 = 1
    id3Version2 = 2
End Enum

Public Enum TFFTGraphHorizontalScale
    gsLogarithmic = 0
    gsLinear = 1
End Enum

Public Enum TFFTGraphParamID
    gpFFTPoints = 1
    gpGraphType
    gpWindow
    gpHorizontalScale
    gpSubgrid
    gpTransparency
    gpFrequencyScaleVisible
    gpDecibelScaleVisible
    gpFrequencyGridVisible
    gpDecibelGridVisible
    gpBgBitmapVisible
    gpBgBitmapHandle
    gpColor1
    gpColor2
    gpColor3
    gpColor4
    gpColor5
    gpColor6
    gpColor7
    gpColor8
    gpColor9
    gpColor10
    gpColor11
    gpColor12
    gpColor13
    gpColor14
    gpColor15
    gpColor16
End Enum

Public Enum TFFTGraphType
    gtLinesLeftOnTop = 0
    gtLinesRightOnTop
    gtAreaLeftOnTop
    gtAreaRightOnTop
    gtBarsLeftOnTop
    gtBarsRightOnTop
    gtSpectrum
End Enum

Public Enum TBPMDetectionMethod
    dmPeaks = 0
    dmAutoCorrelation
End Enum

Public Enum TFFTGraphSize
    FFTGraphMinWidth = 100
    FFTGraphMinHeight = 60
End Enum

Public Enum TWaveOutMapper
    WaveOutWaveMapper = &HFFFFFFFF
End Enum

Public Enum TWaveInMapper
    WaveInWaveMapper = &HFFFFFFFF
End Enum

Public Enum TCallbackMessage
    MsgStopAsync = 1
    MsgPlayAsync = 2
    MsgEnterLoopAsync = 4
    MsgExitLoopAsync = 8
    MsgEnterVolumeSlideAsync = 16
    MsgExitVolumeSlideAsync = 32
    MsgStreamBufferDoneAsync = 64
    MsgStreamNeedMoreDataAsync = 128
    MsgNextSongAsync = 256
    MsgStop = 65536
    MsgPlay = 131072
    MsgEnterLoop = 262144
    MsgExitLoop = 524288
    MsgEnterVolumeSlide = 1048576
    MsgExitVolumeSlide = 2097152
    MsgStreamBufferDone = 4194304
    MsgStreamNeedMoreData = 8388608
    MsgNextSong = 16777216
    MsgWaveBuffer = 33554432
End Enum

Public Enum TWaveOutFormat
    format_invalid = 0
    format_11khz_8bit_mono = 1
    format_11khz_8bit_stereo = 2
    format_11khz_16bit_mono = 4
    format_11khz_16bit_stereo = 8
    format_22khz_8bit_mono = 16
    format_22khz_8bit_stereo = 32
    format_22khz_16bit_mono = 64
    format_22khz_16bit_stereo = 128
    format_44khz_8bit_mono = 256
    format_44khz_8bit_stereo = 512
    format_44khz_16bit_mono = 1024
    format_44khz_16bit_stereo = 2048
End Enum

Public Enum TWaveOutFunctionality
    supportPitchControl = 1
    supportPlaybackRateControl = 2
    supportVolumeControl = 4
    supportSeparateLeftRightVolume = 8
    supportSync = 16
    supportSampleAccuratePosition = 32
    supportDirectSound = 6
End Enum
' ----==== libZplay Public Enums ====----

' ----==== libZplay Public Type ====----
Public Type TStreamHMSTime
    hour As Long
    minute As Long
    second As Long
    millisecond As Long
End Type

Public Type TStreamTime
    sec As Long
    ms As Long
    samples As Long
    hms As TStreamHMSTime
End Type

Public Type TStreamInfo
    SamplingRate As Long
    ChannelNumber As Long
    VBR As Long
    Bitrate As Long
    Length As TStreamTime
    Description As String
End Type

Public Type TWaveOutInfo
    ManufacturerID As Long
    ProductID As Long
    DriverVersion As Long
    Formats As Long
    Channels As Long
    Support As Long
    ProductName As String
End Type

Public Type TWaveInInfo
    ManufacturerID As Long
    ProductID As Long
    DriverVersion As Long
    Formats As Long
    Channels As Long
    ProductName As String
End Type

Public Type TStreamLoadInfo
    NumberOfBuffers As Long
    NumberOfBytes As Long
End Type

Public Type TEchoEffect
    nLeftDelay As Long
    nLeftSrcVolume As Long
    nLeftEchoVolume As Long
    nRightDelay As Long
    nRightSrcVolume As Long
    nRightEchoVolume As Long
End Type

Public Type TStreamStatus
    fPlay As Long
    fPause As Long
    fEcho As Long
    fEqualizer As Long
    fVocalCut As Long
    fSideCut As Long
    fChannelMix As Long
    fSlideVolume As Long
    nLoop As Long
    fReverse As Long
    nSongIndex As Long
    nSongsInQueue As Long
End Type

Public Type TID3Info
    Title As String
    Artist As String
    Album As String
    Year As String
    Comment As String
    Track As String
    Genre As String
End Type

Public Type TID3Picture
    PicturePresent As Boolean
    PictureType As Long
    Description As String
    Bitmap As StdPicture
    BitStream As IUnknown
End Type

Public Type TID3InfoEx
    Title As String
    Artist As String
    Album As String
    Year As String
    Comment As String
    Track As String
    Genre As String
    AlbumArtist As String
    Composer As String
    OriginalArtist As String
    Copyright As String
    URL As String
    Encoder As String
    Publisher As String
    BPM As Long
    Picture As TID3Picture
End Type
' ----==== libZplay Public Type ====----

' ----==== libZplay Private Type Internal ====----
Private Type TStreamInfo_Internal
    SamplingRate As Long
    ChannelNumber As Long
    VBR As Long
    Bitrate As Long
    Length As TStreamTime
    Description As Long
End Type

Private Type TWaveOutInfo_Internal
    ManufacturerID As Long
    ProductID As Long
    DriverVersion As Long
    Formats As Long
    Channels As Long
    Support As Long
    ProductName As Long
End Type

Private Type TWaveInInfo_Internal
    ManufacturerID As Long
    ProductID As Long
    DriverVersion As Long
    Formats As Long
    Channels As Long
    ProductName As Long
End Type

Private Type TID3Info_Internal
    Title As Long
    Artist As Long
    Album As Long
    Year As Long
    Comment As Long
    Track As Long
    Genre As Long
End Type

Private Type TID3InfoEx_Internal
    Title As Long
    Artist As Long
    Album As Long
    Year As Long
    Comment As Long
    Track As Long
    Genre As Long
    AlbumArtist As Long
    Composer As Long
    OriginalArtist As Long
    Copyright As Long
    URL As Long
    Encoder As Long
    Publisher As Long
    BPM As Long
    PicturePresent As Long
    CanDrawPicture As Long
    MIMEType As Long
    PictureType As Long
    Description As Long
    PictureData As Long
    PictureDataSize As Long
    hBitmap As Long
    Width As Long
    Height As Long
    Dummy(65) As Long
    reserved As Long
End Type
' ----==== libZplay Private Type Internal ====----

' ----==== libZplay Declare ====----
Private Declare Function zplay_CreateZPlay Lib "libzplay" () As Long

Private Declare Function zplay_DestroyZPlay Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_SetSettings Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nSettingID As Long, _
                         ByVal Value As Long) As Long

Private Declare Function zplay_GetSettings Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nSettingID As Long) As Long

Private Declare Function zplay_GetError Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_GetErrorW Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_GetVersion Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_GetFileFormat Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As String) As Long

Private Declare Function zplay_GetFileFormatW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As Long) As Long

Private Declare Function zplay_OpenFile Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As String, _
                         ByVal nFormat As Long) As Long

Private Declare Function zplay_OpenFileW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As Long, _
                         ByVal nFormat As Long) As Long

Private Declare Function zplay_AddFile Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As String, _
                         ByVal nFormat As Long) As Long

Private Declare Function zplay_AddFileW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As Long, _
                         ByVal nFormat As Long) As Long

Private Declare Function zplay_OpenStream Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fBuffered As Long, _
                         ByVal fManaged As Long, _
                         ByVal sMemStream As Long, _
                         ByVal nStreamSize As Long, _
                         ByVal nFormat As Long) As Long

Private Declare Function zplay_PushDataToStream Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByRef sMemNewData() As Byte, _
                         ByVal nNewDataize As Long) As Long

Private Declare Function zplay_Close Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_Play Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_Stop Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_Pause Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_Resume Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_IsStreamDataFree Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByRef sMemNewData() As Byte) As Long

Private Declare Sub zplay_GetDynamicStreamLoad Lib "libzplay" ( _
                    ByVal lObjPtr As Long, _
                    ByRef pStreamLoadInfo As TStreamLoadInfo)

Private Declare Sub zplay_GetPosition Lib "libzplay" ( _
                    ByVal lObjPtr As Long, _
                    ByRef pTime As TStreamTime)

Private Declare Function zplay_PlayLoop Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fFormatStartTime As Long, _
                         ByRef pStartTime As TStreamTime, _
                         ByVal fFormatEndTime As Long, _
                         ByRef pEndTime As TStreamTime, _
                         ByVal nNumOfCycles As Long, _
                         ByVal fContinuePlaying As Long) As Long

Private Declare Function zplay_Seek Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fFormat As TTimeFormat, _
                         ByRef pTime As TStreamTime, _
                         ByVal nMoveMethod As TSeekMethod) As Long

Private Declare Function zplay_ReverseMode Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fEnable As Long) As Long

Private Declare Function zplay_SetMasterVolume Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nLeftVolume As Long, _
                         ByVal nRightVolume As Long) As Long

Private Declare Function zplay_SetPlayerVolume Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nLeftVolume As Long, _
                         ByVal nRightVolume As Long) As Long

Private Declare Sub zplay_GetMasterVolume Lib "libzplay" ( _
                    ByVal lObjPtr As Long, _
                    ByRef nLeftVolume As Long, _
                    ByRef nRightVolume As Long)

Private Declare Sub zplay_GetPlayerVolume Lib "libzplay" ( _
                    ByVal lObjPtr As Long, _
                    ByRef nLeftVolume As Long, _
                    ByRef nRightVolume As Long)

Private Declare Function zplay_GetBitrate Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fAverage As Long) As Long

Private Declare Sub zplay_GetStatus Lib "libzplay" ( _
                    ByVal lObjPtr As Long, _
                    ByRef pStatus As TStreamStatus)

Private Declare Function zplay_MixChannels Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fEnable As Long, _
                         ByVal nLeftPercent As Long, _
                         ByVal nRightPercent As Long) As Long

Private Declare Sub zplay_GetVUData Lib "libzplay" ( _
                    ByVal lObjPtr As Long, _
                    ByRef pnLeftChannel As Long, _
                    ByRef pnRightChannel As Long)

Private Declare Function zplay_SlideVolume Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fFormatStart As TTimeFormat, _
                         ByRef pTimeStart As TStreamTime, _
                         ByVal nStartVolumeLeft As Long, _
                         ByVal nStartVolumeRight As Long, _
                         ByVal fFormatEnd As TTimeFormat, _
                         ByRef pTimeEnd As TStreamTime, _
                         ByVal nEndVolumeLeft As Long, _
                         ByVal nEndVolumeRight As Long) As Long

Private Declare Function zplay_EnableEqualizer Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fEnable As Long) As Long

Private Declare Function zplay_SetEqualizerPoints Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal pnFreqPoint As Long, _
                         ByVal nNumOfPoints As Long) As Long

Private Declare Function zplay_GetEqualizerPoints Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal pnFreqPoint As Long, _
                         ByVal nNumOfPoints As Long) As Long

Private Declare Function zplay_SetEqualizerParam Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nPreAmpGain As Long, _
                         ByRef pnBandGain() As Long, _
                         ByVal nNumberOfBands As Long) As Long

Private Declare Function zplay_GetEqualizerParam Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nPreAmpGain As Long, _
                         ByVal pnBandGain As Long, _
                         ByVal nNumberOfBands As Long) As Long

Private Declare Function zplay_SetEqualizerPreampGain Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nGain As Long) As Long

Private Declare Function zplay_GetEqualizerPreampGain Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_SetEqualizerBandGain Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nBandIndex As Long, _
                         ByVal nGain As Long) As Long

Private Declare Function zplay_GetEqualizerBandGain Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nBandIndex As Long) As Long

Private Declare Function zplay_EnableEcho Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fEnable As Long) As Long

Private Declare Function zplay_StereoCut Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal fEnable As Long, _
                         ByVal fOutputCenter As Long, _
                         ByVal fBassToSides As Long) As Long

Private Declare Function zplay_SetEchoParam Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal pEchoEffect As Long, _
                         ByVal nNumberOfEffects As Long) As Long

Private Declare Function zplay_GetEchoParam Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal pEchoEffect As Long, _
                         ByVal nNumberOfEffects As Long) As Long

Private Declare Function zplay_GetFFTData Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nFFTPoints As Long, _
                         ByVal nFFTWindow As Long, _
                         ByRef pnHarmonicNumber As Long, _
                         ByRef pnHarmonicFreq() As Long, _
                         ByRef pnLeftAmplitude() As Long, _
                         ByRef pnRightAmplitude() As Long, _
                         ByRef pnLeftPhase() As Long, _
                         ByRef pnRightPhase() As Long) As Long

Private Declare Function zplay_SetRate Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nRate As Long) As Long

Private Declare Function zplay_GetRate Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_SetPitch Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nPitch As Long) As Long

Private Declare Function zplay_GetPitch Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_SetTempo Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nTempo As Long) As Long

Private Declare Function zplay_GetTempo Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_DrawFFTGraphOnHDC Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal hdc As Long, _
                         ByVal nX As Long, _
                         ByVal nY As Long, _
                         ByVal nWidth As Long, _
                         ByVal nHeight As Long) As Long

Private Declare Function zplay_DrawFFTGraphOnHWND Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal hwnd As Long, _
                         ByVal nX As Long, _
                         ByVal nY As Long, _
                         ByVal nWidth As Long, _
                         ByVal nHeight As Long) As Long

Private Declare Function zplay_SetFFTGraphParam Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nParamID As Long, _
                         ByVal nParamValue As Long) As Long

Private Declare Function zplay_GetFFTGraphParam Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nParamID As Long) As Long

Private Declare Function zplay_LoadID3W Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nId3Version As Long, _
                         ByRef pId3Info As TID3Info_Internal) As Long

Private Declare Function zplay_LoadFileID3W Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal pchFileName As Long, _
                         ByVal nFormat As Long, _
                         ByVal nId3Version As Long, _
                         ByRef pId3Info As TID3Info_Internal) As Long

Private Declare Function zplay_DetectBPM Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nMethod As Long) As Long

Private Declare Function zplay_DetectFileBPM Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As String, _
                         ByVal nFormat As Long, _
                         ByVal nMethod As Long) As Long

Private Declare Function zplay_DetectFileBPMW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As Long, _
                         ByVal nFormat As Long, _
                         ByVal nMethod As Long) As Long

Private Declare Function zplay_SetCallbackFunc Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal pCallbackFunc As Long, _
                         ByVal nMessage As TCallbackMessage, _
                         ByVal user_data As Long) As Long

Private Declare Function zplay_EnumerateWaveIn Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_GetWaveInInfoW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nIndex As Long, _
                         ByRef pWaveInInfo As TWaveInInfo_Internal) As Long

Private Declare Function zplay_SetWaveInDevice Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nIndex As Long) As Long

Private Declare Function zplay_EnumerateWaveOut Lib "libzplay" ( _
                         ByVal lObjPtr As Long) As Long

Private Declare Function zplay_GetWaveOutInfoW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nIndex As Long, _
                         ByRef pWaveOutInfo As TWaveOutInfo_Internal) As Long

Private Declare Function zplay_SetWaveOutDevice Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal nIndex As Long) As Long

Private Declare Function zplay_GetStreamInfoW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByRef pInfo As TStreamInfo_Internal) As Long

Private Declare Function zplay_LoadID3ExW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByRef pInfo As TID3InfoEx_Internal, _
                         ByVal fDecodeEmbededPicture As Long) As Long

Private Declare Function zplay_LoadFileID3ExW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As Long, _
                         ByVal nFormat As Long, _
                         ByRef pInfo As TID3InfoEx_Internal, _
                         ByVal fDecodeEmbededPicture As Long) As Long

Private Declare Function zplay_SetWaveOutFileW Lib "libzplay" ( _
                         ByVal lObjPtr As Long, _
                         ByVal sFileName As Long, _
                         ByVal nFormat As Long, _
                         ByVal fOutputToSoundcard As Long) As Long

' ----==== Kernel32 Declare ====----
Private Declare Sub CopyMemory Lib "kernel32" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)

Private Declare Function lstrlenW Lib "kernel32" ( _
                         ByVal lpString As Long) As Long

' ----==== OLE32 API Declarationen ====----
Private Declare Function CreateStreamOnHGlobal Lib "ole32.dll" ( _
                         ByRef hGlobal As Any, _
                         ByVal fDeleteOnRelease As Long, _
                         ByRef ppstm As Any) As Long

' ----==== OLEAUT32 Types ====----
Private Type IID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7)  As Byte
End Type

Private Type PICTDESC
    cbSizeOfStruct As Long
    picType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

' ----==== OLEAUT32 API Declarations ====----
Private Declare Sub OleCreatePictureIndirect Lib "oleaut32.dll" ( _
                    ByRef lpPictDesc As PICTDESC, _
                    ByRef riid As IID, _
                    ByVal fOwn As Boolean, _
                    ByRef lplpvObj As Object)

' ----==== GDIPlus Types ====----
Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

' ----==== GDI+ API Declarationen ====----
Private Declare Function GdiplusShutdown Lib "gdiplus" ( _
                         ByVal Token As Long) As Long

Private Declare Function GdiplusStartup Lib "gdiplus" ( _
                         ByRef Token As Long, _
                         ByRef lpInput As GDIPlusStartupInput, _
                         ByRef lpOutput As GdiplusStartupOutput) As Long

Private Declare Function GdipLoadImageFromStream Lib "gdiplus" ( _
                         ByVal Stream As IUnknown, _
                         ByRef Image As Long) As Long

Private Declare Function GdipCreateHBITMAPFromBitmap Lib "gdiplus" ( _
                         ByVal Bitmap As Long, _
                         ByRef hBmReturn As Long, _
                         ByVal Background As Long) As Long

Private Declare Function GdipDisposeImage Lib "gdiplus" ( _
                         ByVal Image As Long) As Long

' ----==== Variablen ====----
Private GdipToken As Long
Private oPlayer As Long

Public Function TCallbackFunc(ByVal lObjPtr As Long, ByVal user_data As Long, ByVal _
    msg As TCallbackMessage, ByVal param1 As Long, ByVal param2 As Long) As Long

    TCallbackFunc = 0

End Function

Public Function Initialize() As Boolean

    Dim bRet As Boolean

    bRet = False

    Call Terminate

    oPlayer = zplay_CreateZPlay

    If oPlayer = 0 Then

        Call MsgBox("Can't create libZPlay interface.", vbInformation Or vbOKOnly)

    Else

        If GetVersion < 190 Then

            Call MsgBox("Need libZPlay.dll version 1.90 and above.", vbInformation _
                Or vbOKOnly)

        End If

    End If

    If oPlayer <> 0 Then bRet = True

    Initialize = bRet

End Function

Public Function Terminate() As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_DestroyZPlay(oPlayer))

        oPlayer = 0

    End If

    Terminate = bRet

End Function

' #Region "Version"
Public Function GetVersion() As Long

    If oPlayer <> 0 Then

        GetVersion = zplay_GetVersion(oPlayer)

    End If

End Function

' #End Region

' #Region "Error handling"
Public Function GetError() As String

    If oPlayer <> 0 Then

        GetError = PointerToString(zplay_GetErrorW(oPlayer))

    End If

End Function

' #End Region

' #Region "Open and close stream"
Public Function GetFileFormat(ByVal FileName As String) As TStreamFormat

    Dim pStr As Long

    If oPlayer <> 0 Then

        pStr = StrPtr(FileName)
        GetFileFormat = zplay_GetFileFormatW(oPlayer, pStr)

    End If

End Function

Public Function OpenFile(ByVal FileName As String, ByVal Format As TStreamFormat) _
    As Boolean

    Dim pStr As Long
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        pStr = StrPtr(FileName)
        bRet = CBool(zplay_OpenFileW(oPlayer, pStr, Format))

    End If

    OpenFile = bRet

End Function

Public Function SetWaveOutFile(ByVal FileName As String, ByVal Format As _
    TStreamFormat, ByRef fOutputToSoundcard As Boolean) As Boolean

    Dim s As Long
    Dim pStr As Long
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then
        If fOutputToSoundcard Then

            s = 1

        End If

        pStr = StrPtr(FileName)
        bRet = CBool(zplay_SetWaveOutFileW(oPlayer, pStr, Format, s))

    End If

    SetWaveOutFile = bRet

End Function

Public Function AddFile(ByVal FileName As String, ByVal Format As TStreamFormat) _
    As Boolean

    Dim pStr As Long
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        pStr = StrPtr(FileName)
        bRet = CBool(zplay_AddFileW(oPlayer, pStr, Format))

    End If

    AddFile = bRet

End Function

Public Function OpenStream(ByVal Buffered As Boolean, ByVal Dynamic As Boolean, _
    ByRef MemStream() As Byte, ByVal StreamSize As Long, ByVal nFormat As _
    TStreamFormat) As Boolean

    Dim pMemStream As Long
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        pMemStream = VarPtr(MemStream(0))

        bRet = CBool(zplay_OpenStream(oPlayer, CLng(Abs(Buffered)), CLng(Abs( _
            Dynamic)), pMemStream, StreamSize, nFormat))

    End If

    OpenStream = bRet

End Function

Public Function PushDataToStream(ByRef MemNewData() As Byte, ByVal NewDatSize As _
    Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_PushDataToStream(oPlayer, MemNewData, NewDatSize))

    End If

    PushDataToStream = bRet

End Function

Public Function IsStreamDataFree(ByRef MemNewData() As Byte) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_IsStreamDataFree(oPlayer, MemNewData))

    End If

    IsStreamDataFree = bRet

End Function

Public Function StreamClose() As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_Close(oPlayer))

    End If

    StreamClose = bRet

End Function

' #End Region

' #Region "Position and Seek"
Public Sub GetPosition(ByRef time As TStreamTime)

    If oPlayer <> 0 Then

        Call zplay_GetPosition(oPlayer, time)

    End If

End Sub

Public Function SeekPosition(ByVal TimeFormat As TTimeFormat, ByRef position As _
    TStreamTime, ByVal MoveMethod As TSeekMethod) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_Seek(oPlayer, TimeFormat, position, MoveMethod))

    End If

    SeekPosition = bRet

End Function

' #End Region

' #Region "Play, Pause, Loop, Reverse"
Public Function ReverseMode(ByVal Enable As Boolean) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_ReverseMode(oPlayer, CLng(Abs(Enable))))

    End If

    ReverseMode = bRet

End Function

Public Function PlayLoop(ByVal TimeFormatStart As TTimeFormat, ByRef StartPosition _
    As TStreamTime, ByVal TimeFormatEnd As TTimeFormat, ByRef EndPosition As _
    TStreamTime, ByVal NumberOfCycles As Long, ByVal ContinuePlaying As Boolean) _
    As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_PlayLoop(oPlayer, TimeFormatStart, StartPosition, _
            TimeFormatEnd, EndPosition, NumberOfCycles, CLng(Abs( _
            ContinuePlaying))))

    End If

    PlayLoop = bRet

End Function

Public Function StartPlayback() As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_Play(oPlayer))

    End If

    StartPlayback = bRet

End Function

Public Function StopPlayback() As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_Stop(oPlayer))

    End If

    StopPlayback = bRet

End Function

Public Function PausePlayback() As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_Pause(oPlayer))

    End If

    PausePlayback = bRet

End Function

Public Function ResumePlayback() As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_Resume(oPlayer))

    End If

    ResumePlayback = bRet

End Function

' #End Region

' #Region "Equalizer"
Public Function SetEqualizerParam(ByVal PreAmpGain As Long, ByRef BandGain() As _
    Long, ByVal NumberOfBands As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetEqualizerParam(oPlayer, PreAmpGain, BandGain, _
            NumberOfBands))

    End If

    SetEqualizerParam = bRet

End Function

Public Function GetEqualizerParam(ByRef PreAmpGain As Long, ByRef BandGain() As _
    Long) As Long

    Dim size As Long
    Dim lRet As Long
    Dim pBandGain As Long
    Dim tempnPreAmpGain1 As Long

    If oPlayer <> 0 Then

        size = zplay_GetEqualizerParam(oPlayer, tempnPreAmpGain1, 0&, 0&)

        ReDim BandGain(size)

        pBandGain = VarPtr(BandGain(0))

        lRet = zplay_GetEqualizerParam(oPlayer, PreAmpGain, pBandGain, size)

    End If

    GetEqualizerParam = lRet

End Function

Public Function EnableEqualizer(ByVal Enable As Boolean) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_EnableEqualizer(oPlayer, CLng(Abs(Enable))))

    End If

    EnableEqualizer = bRet

End Function

Public Function SetEqualizerPreampGain(ByVal Gain As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetEqualizerPreampGain(oPlayer, Gain))

    End If

    SetEqualizerPreampGain = bRet

End Function

Public Function GetEqualizerPreampGain() As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_GetEqualizerPreampGain(oPlayer)

    End If

    GetEqualizerPreampGain = lRet

End Function

Public Function SetEqualizerBandGain(ByVal BandIndex As Long, ByVal Gain As Long) _
    As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetEqualizerBandGain(oPlayer, BandIndex, Gain))

    End If

    SetEqualizerBandGain = bRet

End Function

Public Function GetEqualizerBandGain(ByVal BandIndex As Long) As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_GetEqualizerBandGain(oPlayer, BandIndex)

    End If

    GetEqualizerBandGain = lRet

End Function

Public Function SetEqualizerPoints(ByRef FreqPointArray() As Long, ByVal _
    NumberOfPoints As Long) As Boolean

    Dim pFreqPointArray As Long
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        pFreqPointArray = VarPtr(FreqPointArray(0))

        bRet = CBool(zplay_SetEqualizerPoints(oPlayer, pFreqPointArray, _
            NumberOfPoints))

    End If

    SetEqualizerPoints = bRet

End Function

Public Function GetEqualizerPoints(ByRef FreqPointArray() As Long) As Long

    Dim lRet As Long
    Dim size As Long
    Dim pFreqPointArray As Long

    If oPlayer <> 0 Then

        size = zplay_GetEqualizerPoints(oPlayer, 0&, 0&)

        ReDim FreqPointArray(size)

        pFreqPointArray = VarPtr(FreqPointArray(0))

        lRet = zplay_GetEqualizerPoints(oPlayer, pFreqPointArray, size)

    End If

    GetEqualizerPoints = lRet

End Function

' #End Region

' #Region "Echo"
Public Function EnableEcho(ByVal Enable As Boolean) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_EnableEcho(oPlayer, CLng(Abs(Enable))))

    End If

    EnableEcho = bRet

End Function

Public Function SetEchoParam(ByRef EchoEffectArray() As TEchoEffect, ByVal _
    NumberOfEffects As Long) As Boolean

    Dim bRet As Boolean
    Dim pEchoEffectArray As Long

    bRet = False

    If oPlayer <> 0 Then

        pEchoEffectArray = VarPtr(EchoEffectArray(0))

        bRet = CBool(zplay_SetEchoParam(oPlayer, pEchoEffectArray, NumberOfEffects))

    End If

    SetEchoParam = bRet

End Function

Public Function GetEchoParam(ByRef EchoEffectArray() As TEchoEffect) As Long

    Dim lRet As Long
    Dim size As Long
    Dim pEchoEffectArray As Long

    If oPlayer <> 0 Then

        size = zplay_GetEchoParam(oPlayer, 0&, 0&)

        ReDim EchoEffectArray(size)

        pEchoEffectArray = VarPtr(EchoEffectArray(0))

        lRet = zplay_GetEchoParam(oPlayer, pEchoEffectArray, size)

    End If

    GetEchoParam = lRet

End Function

' #End Region

' #Region "Volume and Fade"
Public Function SetMasterVolume(ByVal LeftVolume As Long, ByVal RightVolume As _
    Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetMasterVolume(oPlayer, LeftVolume, RightVolume))

    End If

    SetMasterVolume = bRet

End Function

Public Function SetPlayerVolume(ByVal LeftVolume As Long, ByVal RightVolume As _
    Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetPlayerVolume(oPlayer, LeftVolume, RightVolume))

    End If

    SetPlayerVolume = bRet

End Function

Public Sub GetMasterVolume(ByRef LeftVolume As Long, ByRef RightVolume As Long)

    If oPlayer <> 0 Then

        Call zplay_GetMasterVolume(oPlayer, LeftVolume, RightVolume)

    End If

End Sub

Public Sub GetPlayerVolume(ByRef LeftVolume As Long, ByRef RightVolume As Long)

    If oPlayer <> 0 Then

        Call zplay_GetPlayerVolume(oPlayer, LeftVolume, RightVolume)

    End If

End Sub

Public Function SlideVolume(ByVal TimeFormatStart As TTimeFormat, ByRef TimeStart _
    As TStreamTime, ByVal StartVolumeLeft As Long, ByVal StartVolumeRight As Long, _
    ByVal TimeFormatEnd As TTimeFormat, ByRef TimeEnd As TStreamTime, ByVal _
    EndVolumeLeft As Long, ByVal EndVolumeRight As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SlideVolume(oPlayer, TimeFormatStart, TimeStart, _
            StartVolumeLeft, StartVolumeRight, TimeFormatEnd, TimeEnd, _
            EndVolumeLeft, EndVolumeRight))

    End If

    SlideVolume = bRet

End Function

' #End Region

' #Region "Pitch, tempo, rate"
Public Function SetPitch(ByVal Pitch As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetPitch(oPlayer, Pitch))

    End If

    SetPitch = bRet

End Function

Public Function GetPitch() As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_GetPitch(oPlayer)

    End If

    GetPitch = lRet

End Function

Public Function SetRate(ByVal Rate As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetRate(oPlayer, Rate))

    End If

    SetRate = bRet

End Function

Public Function GetRate() As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_GetRate(oPlayer)

    End If

    GetRate = lRet

End Function

Public Function SetTempo(ByVal Tempo As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetTempo(oPlayer, Tempo))

    End If

    SetTempo = bRet

End Function

Public Function GetTempo() As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_GetTempo(oPlayer)

    End If

    GetTempo = lRet

End Function

' #End Region

' #Region "Bitrate"
Public Function GetBitrate(ByVal Average As Boolean) As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_GetBitrate(oPlayer, CLng(Abs(Average)))

    End If

    GetBitrate = lRet

End Function

' #End Region

' #Region "ID3 Info"
Public Function LoadID3(ByVal Id3Version As TID3Version, ByRef info As TID3Info) _
    As Boolean

    Dim tmp As TID3Info_Internal
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        If CBool(zplay_LoadID3W(oPlayer, Id3Version, tmp)) = True Then

            bRet = True

            info.Album = PointerToString(tmp.Album)
            info.Artist = PointerToString(tmp.Artist)
            info.Comment = PointerToString(tmp.Comment)
            info.Genre = PointerToString(tmp.Genre)
            info.Title = PointerToString(tmp.Title)
            info.Track = PointerToString(tmp.Track)
            info.Year = PointerToString(tmp.Year)

        End If

    End If

    LoadID3 = bRet

End Function

Public Function LoadID3Ex(ByRef info As TID3InfoEx, ByVal fDecodePicture As _
    Boolean) As Boolean

    Dim bRet As Boolean
    Dim tmp As TID3InfoEx_Internal

    bRet = False

    If oPlayer <> 0 Then

        If CBool(zplay_LoadID3ExW(oPlayer, tmp, 0)) = True Then

            bRet = True

            info.Album = PointerToString(tmp.Album)
            info.Artist = PointerToString(tmp.Artist)
            info.Comment = PointerToString(tmp.Comment)
            info.Genre = PointerToString(tmp.Genre)
            info.Title = PointerToString(tmp.Title)
            info.Track = PointerToString(tmp.Track)
            info.Year = PointerToString(tmp.Year)
            info.AlbumArtist = PointerToString(tmp.AlbumArtist)
            info.Composer = PointerToString(tmp.Composer)
            info.OriginalArtist = PointerToString(tmp.OriginalArtist)
            info.Copyright = PointerToString(tmp.Copyright)
            info.Encoder = PointerToString(tmp.Encoder)
            info.Publisher = PointerToString(tmp.Publisher)
            info.BPM = tmp.BPM
            info.Picture.PicturePresent = False

            If fDecodePicture Then
                If tmp.PicturePresent = 1 Then

                    Dim stream_data() As Byte

                    ReDim stream_data(tmp.PictureDataSize)

                    CopyMemory stream_data(0), ByVal tmp.PictureData, _
                        tmp.PictureDataSize

                    If CreateStreamOnHGlobal(stream_data(0), False, _
                        info.Picture.BitStream) = 0 Then

                        Set info.Picture.Bitmap = StreamToPicture( _
                            info.Picture.BitStream)

                        Set info.Picture.BitStream = Nothing

                    End If

                    info.Picture.PictureType = tmp.PictureType
                    info.Picture.Description = PointerToString(tmp.Description)
                    info.Picture.PicturePresent = True

                Else

                    Set info.Picture.Bitmap = LoadPicture("")

                    info.Picture.PicturePresent = False

                End If
            End If
        End If
    End If

    LoadID3Ex = bRet

End Function

Public Function LoadFileID3(ByVal FileName As String, ByVal Format As _
    TStreamFormat, ByVal Id3Version As TID3Version, ByRef info As TID3Info) As _
    Boolean

    Dim tmp As TID3Info_Internal
    Dim pStr As Long
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        pStr = StrPtr(FileName)

        If CBool(zplay_LoadFileID3W(oPlayer, pStr, Format, Id3Version, tmp)) = _
            True Then

            bRet = True

            info.Album = PointerToString(tmp.Album)
            info.Artist = PointerToString(tmp.Artist)
            info.Comment = PointerToString(tmp.Comment)
            info.Genre = PointerToString(tmp.Genre)
            info.Title = PointerToString(tmp.Title)
            info.Track = PointerToString(tmp.Track)
            info.Year = PointerToString(tmp.Year)

        End If

    End If

    LoadFileID3 = bRet

End Function

Public Function LoadFileID3Ex(ByVal FileName As String, ByVal Format As _
    TStreamFormat, ByRef info As TID3InfoEx, ByVal fDecodePicture As Boolean) As _
    Boolean

    Dim tmp As TID3InfoEx_Internal
    Dim pStr As Long
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        pStr = StrPtr(FileName)

        If CBool(zplay_LoadFileID3ExW(oPlayer, pStr, Format, tmp, 0)) = True Then

            bRet = True

            info.Album = PointerToString(tmp.Album)
            info.Artist = PointerToString(tmp.Artist)
            info.Comment = PointerToString(tmp.Comment)
            info.Genre = PointerToString(tmp.Genre)
            info.Title = PointerToString(tmp.Title)
            info.Track = PointerToString(tmp.Track)
            info.Year = PointerToString(tmp.Year)
            info.AlbumArtist = PointerToString(tmp.AlbumArtist)
            info.Composer = PointerToString(tmp.Composer)
            info.OriginalArtist = PointerToString(tmp.OriginalArtist)
            info.Copyright = PointerToString(tmp.Copyright)
            info.Encoder = PointerToString(tmp.Encoder)
            info.Publisher = PointerToString(tmp.Publisher)
            info.BPM = tmp.BPM
            info.Picture.PicturePresent = False

            If fDecodePicture Then
                If tmp.PicturePresent = 1 Then

                    Dim stream_data() As Byte

                    ReDim stream_data(tmp.PictureDataSize)

                    CopyMemory stream_data(0), ByVal tmp.PictureData, _
                        tmp.PictureDataSize

                    If CreateStreamOnHGlobal(stream_data(0), False, _
                        info.Picture.BitStream) = 0 Then

                        Set info.Picture.Bitmap = StreamToPicture( _
                            info.Picture.BitStream)

                        Set info.Picture.BitStream = Nothing

                    End If

                    info.Picture.PictureType = tmp.PictureType
                    info.Picture.Description = PointerToString(tmp.Description)
                    info.Picture.PicturePresent = True

                Else

                    Set info.Picture.Bitmap = LoadPicture("")

                    info.Picture.PicturePresent = False

                End If
            End If
        End If
    End If

    LoadFileID3Ex = bRet

End Function

' #End Region

' #Region "Callback"
Public Function SetCallbackFunc(ByVal Messages As TCallbackMessage, ByVal UserData _
    As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetCallbackFunc(oPlayer, AddressOf TCallbackFunc, _
            Messages, UserData))

    End If

    SetCallbackFunc = bRet

End Function

' #End Region

' #Region "Beat-Per-Minute"
Public Function DetectBPM(ByVal Method As TBPMDetectionMethod) As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_DetectBPM(oPlayer, Method)

    End If

    DetectBPM = lRet

End Function

Public Function DetectFileBPM(ByVal FileName As String, ByVal Format As _
    TStreamFormat, ByVal Method As TBPMDetectionMethod) As Long

    Dim pStr As Long
    Dim lRet As Long

    If oPlayer <> 0 Then

        pStr = StrPtr(FileName)

        lRet = zplay_DetectFileBPMW(oPlayer, pStr, Format, Method)

    End If

    DetectFileBPM = lRet

End Function

' #End Region

' #Region "FFT Graph and FFT values"
Public Function GetFFTData(ByVal FFTPoints As Long, ByVal FFTWindow As TFFTWindow, _
    ByRef HarmonicNumber As Long, ByRef HarmonicFreq() As Long, ByRef _
    LeftAmplitude() As Long, ByRef RightAmplitude() As Long, ByRef LeftPhase() As _
    Long, ByRef RightPhase() As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_GetFFTData(oPlayer, FFTPoints, FFTWindow, _
            HarmonicNumber, HarmonicFreq, LeftAmplitude, RightAmplitude, _
            LeftPhase, RightPhase))

    End If

    GetFFTData = bRet

End Function

Public Function DrawFFTGraphOnHDC(ByVal hdc As Long, ByVal X As Long, ByVal Y As _
    Long, ByVal Width As Long, ByVal Height As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_DrawFFTGraphOnHDC(oPlayer, hdc, X, Y, Width, Height))

    End If

    DrawFFTGraphOnHDC = bRet

End Function

Public Function DrawFFTGraphOnHWND(ByVal hwnd As Long, ByVal X As Long, ByVal Y As _
    Long, ByVal Width As Long, ByVal Height As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_DrawFFTGraphOnHWND(oPlayer, hwnd, X, Y, Width, Height))

    End If

    DrawFFTGraphOnHWND = bRet

End Function

Public Function SetFFTGraphParam(ByVal ParamID As TFFTGraphParamID, ByVal _
    ParamValue As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetFFTGraphParam(oPlayer, ParamID, ParamValue))

    End If

    SetFFTGraphParam = bRet

End Function

Public Function GetFFTGraphParam(ByVal ParamID As TFFTGraphParamID) As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_GetFFTGraphParam(oPlayer, ParamID)

    End If

    GetFFTGraphParam = lRet

End Function

' #End Region

' #Region "Center and side cut"
Public Function StereoCut(ByVal Enable As Boolean, ByVal OutputCenter As Boolean, _
    ByVal BassToSides As Boolean) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_StereoCut(oPlayer, CLng(Abs(Enable)), CLng(Abs( _
            OutputCenter)), CLng(Abs(BassToSides))))

    End If

    StereoCut = bRet

End Function

' #End Region

' #Region "Channel mixing"
Public Function MixChannels(ByVal Enable As Boolean, ByVal LeftPercent As Long, _
    ByVal RightPercent As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_MixChannels(oPlayer, CLng(Abs(Enable)), LeftPercent, _
            RightPercent))

    End If

    MixChannels = bRet

End Function

' #End Region

' #Region "VU Data"
Public Sub GetVUData(ByRef LeftChannel As Long, ByRef RightChannel As Long)

    If oPlayer <> 0 Then

        Call zplay_GetVUData(oPlayer, LeftChannel, RightChannel)

    End If

End Sub

' #End Region

' #Region "Status and Info"
Public Sub GetStreamInfo(ByRef info As TStreamInfo)

    Dim tmp As TStreamInfo_Internal

    If oPlayer <> 0 Then

        If CBool(zplay_GetStreamInfoW(oPlayer, tmp)) = True Then

            info.Bitrate = tmp.Bitrate
            info.ChannelNumber = tmp.ChannelNumber
            info.SamplingRate = tmp.SamplingRate
            info.VBR = tmp.VBR
            info.Length = tmp.Length
            info.Description = PointerToString(tmp.Description)

        End If
    End If

End Sub

Public Sub GetStatus(ByRef status As TStreamStatus)

    If oPlayer <> 0 Then

        Call zplay_GetStatus(oPlayer, status)

    End If

End Sub

Public Sub GetDynamicStreamLoad(ByRef StreamLoadInfo As TStreamLoadInfo)

    If oPlayer <> 0 Then

        Call zplay_GetDynamicStreamLoad(oPlayer, StreamLoadInfo)

    End If

End Sub

' #End Region

' #Region "Wave Out and Wave In Info"
Public Function EnumerateWaveOut() As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_EnumerateWaveOut(oPlayer)

    End If

    EnumerateWaveOut = lRet

End Function

Public Function GetWaveOutInfo(ByVal Index As Long, ByRef info As TWaveOutInfo) As _
    Boolean

    Dim tmp As TWaveOutInfo_Internal
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        If CBool(zplay_GetWaveOutInfoW(oPlayer, Index, tmp)) = True Then

            bRet = True

            info.Channels = tmp.Channels
            info.DriverVersion = tmp.DriverVersion
            info.Formats = tmp.Formats
            info.ManufacturerID = tmp.ManufacturerID
            info.ProductID = tmp.ProductID
            info.Support = tmp.Support
            info.ProductName = PointerToString(tmp.ProductName)

        End If
    End If

    GetWaveOutInfo = bRet

End Function

Public Function SetWaveOutDevice(ByVal Index As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then

        bRet = CBool(zplay_SetWaveOutDevice(oPlayer, Index))

    End If

    SetWaveOutDevice = bRet

End Function

Public Function EnumerateWaveIn() As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_EnumerateWaveIn(oPlayer)

    End If

    EnumerateWaveIn = lRet

End Function

Public Function GetWaveInInfo(ByVal Index As Long, ByRef info As TWaveInInfo) As _
    Boolean

    Dim tmp As TWaveInInfo_Internal
    Dim bRet As Boolean

    bRet = False

    If oPlayer <> 0 Then
        If CBool(zplay_GetWaveInInfoW(oPlayer, Index, tmp)) = True Then

            bRet = True

            info.Channels = tmp.Channels
            info.DriverVersion = tmp.DriverVersion
            info.Formats = tmp.Formats
            info.ManufacturerID = tmp.ManufacturerID
            info.ProductID = tmp.ProductID
            info.ProductName = PointerToString(tmp.ProductName)

        End If
    End If

    GetWaveInInfo = bRet

End Function

' #End Region

' #Region "Settings"
Public Function SetSettings(ByVal SettingID As TSettingID, ByVal Value As Long) As _
    Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_SetSettings(oPlayer, SettingID, Value)

    End If

    SetSettings = lRet

End Function

Public Function GetSettings(ByVal SettingID As TSettingID) As Long

    Dim lRet As Long

    If oPlayer <> 0 Then

        lRet = zplay_GetSettings(oPlayer, SettingID)

    End If

    GetSettings = lRet

End Function

' #End Region

' ----==== Hilfsfunktion ====----
Private Function StartUpGDIPlus() As Long

    Dim GdipStartupInput As GDIPlusStartupInput
    Dim GdipStartupOutput As GdiplusStartupOutput

    GdipStartupInput.GdiPlusVersion = 1
    StartUpGDIPlus = GdiplusStartup(GdipToken, GdipStartupInput, GdipStartupOutput)

End Function

Private Function ShutdownGDIPlus() As Long

    If GdiplusShutdown(GdipToken) = 0 Then

        GdipToken = 0
        ShutdownGDIPlus = 0

    End If

End Function

Private Function StreamToPicture(ByVal PicStream As IUnknown) As StdPicture

    Dim lBitmap As Long
    Dim hBitmap As Long

    If StartUpGDIPlus = 0 Then
        If GdipLoadImageFromStream(PicStream, lBitmap) = 0 Then
            If GdipCreateHBITMAPFromBitmap(lBitmap, hBitmap, 0) = 0 Then

                Set StreamToPicture = HandleToPicture(hBitmap, vbPicTypeBitmap)

            End If

            Call GdipDisposeImage(lBitmap)

        End If

        Call ShutdownGDIPlus

    End If

End Function

Private Function HandleToPicture(ByVal hGDIHandle As Long, ByVal ObjectType As _
    PictureTypeConstants, Optional ByVal hPal As Long = 0) As StdPicture

    Dim tPictDesc As PICTDESC
    Dim IID_IPicture As IID
    Dim oPicture As IPicture

    With tPictDesc

        .cbSizeOfStruct = Len(tPictDesc)
        .picType = ObjectType
        .hgdiObj = hGDIHandle
        .hPalOrXYExt = hPal

    End With

    With IID_IPicture

        .Data1 = &H7BF80981
        .Data2 = &HBF32
        .Data3 = &H101A
        .Data4(0) = &H8B
        .Data4(1) = &HBB
        .Data4(3) = &HAA
        .Data4(5) = &H30
        .Data4(6) = &HC
        .Data4(7) = &HAB

    End With

    Call OleCreatePictureIndirect(tPictDesc, IID_IPicture, True, oPicture)

    Set HandleToPicture = oPicture

End Function

Private Function PointerToString(ByVal lngPtr As Long) As String

    Dim lngLen As Long
    Dim strTemp As String
    Dim sRet As String

    If lngPtr Then

        lngLen = lstrlenW(lngPtr) * 2

        If lngLen Then

            strTemp = Space(lngLen)
            CopyMemory ByVal strTemp, ByVal lngPtr, lngLen
            sRet = Replace(strTemp, vbNullChar, vbNullString)

        End If
    End If

    PointerToString = sRet

End Function

' ----==== Hilfsfunktion ====----


